SystemOrganization addCategory: #OLE!

SketchMorph subclass: #RippedOffMorph
	instanceVariableNames: 'target patch'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!RippedOffMorph methodsFor: 'initialization' stamp: 'lg 9/25/2007 11:21'!
justDroppedInto: morph event: evt
	super justDroppedInto: morph event: evt.
	morph == patch ifTrue: [self replacePatch: morph].! !

!RippedOffMorph methodsFor: '*ole' stamp: 'lg 9/25/2007 12:07'!
replacePatch: patchMorph
	target extent: patchMorph extent; position: patchMorph position.
	patch owner replaceSubmorph: patchMorph by: target.
	OLE congratulate.! !

!RippedOffMorph methodsFor: 'initialization' stamp: 'lg 9/25/2007 11:22'!
setPatch: morph 
	patch := morph.
! !

!RippedOffMorph methodsFor: 'initialization' stamp: 'lg 9/25/2007 10:26'!
setTarget: morph 
	target := morph.
	self form: target imageForm.! !

!Symbol methodsFor: '*ole' stamp: 'jwl 10/1/2007 17:40'!
value: x 
	^ x perform: self.
! !

Object subclass: #OLE
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!OLE class methodsFor: 'sound effects' stamp: 'lg 9/29/2007 13:02'!
congratulate
	"Not implemented" nil.! !

TextMorph subclass: #GameTextMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!GameTextMorph methodsFor: 'game value' stamp: 'lg 10/1/2007 16:34'!
getGameValue
	^self getNumericValue.! !

!GameTextMorph methodsFor: 'game value' stamp: 'lg 10/1/2007 16:08'!
increment
	self setNumericValue: self getNumericValue + 1.! !

!GameTextMorph methodsFor: 'as yet unclassified' stamp: 'lg 10/1/2007 15:25'!
isGameInput
	^true! !

!GameTextMorph methodsFor: 'game value' stamp: 'lg 10/1/2007 16:08'!
setGameValue: n 
	self setNumericValue: n.! !

RectangleMorph subclass: #NumberGame
	instanceVariableNames: 'minValue maxSum'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!NumberGame class methodsFor: 'game' stamp: 'lg 10/1/2007 16:29'!
answer: n 
	World allMorphsDo: [ :m | (m isKindOf: self) ifTrue: [m answer: n]].
! !

!NumberGame methodsFor: 'game' stamp: 'lg 10/1/2007 16:32'!
answer: n
	n = self getGameValue ifTrue: [self beep: 'clink'. self newGame]
								 ifFalse: [self beep: 'horn'].
! !

!NumberGame methodsFor: 'as yet unclassified' stamp: 'lg 10/2/2007 15:33'!
gameChoices
	^World allMorphs select: #isGameChoice.! !

!NumberGame methodsFor: 'as yet unclassified' stamp: 'lg 10/1/2007 15:30'!
gameInputs
	^World allMorphs select: #isGameInput.! !

!NumberGame methodsFor: 'game' stamp: 'lg 10/1/2007 16:34'!
getGameValue
	^(self gameInputs collect: #getGameValue) sum.! !

!NumberGame methodsFor: 'game' stamp: 'lg 10/1/2007 16:17'!
increaseInputs
	| seed |
	seed := (0 to: maxSum - (minValue * self gameInputs size)) atRandom.
	seed timesRepeat: [ self gameInputs atRandom increment ].
! !

!NumberGame methodsFor: 'as yet unclassified' stamp: 'jwl 10/1/2007 17:37'!
initialize
	super initialize.
	minValue := 1.
	maxSum := 9.! !

!NumberGame methodsFor: 'as yet unclassified' stamp: 'lg 10/2/2007 15:08'!
newGame
	self resetInputs; increaseInputs; updateChoices.
! !

!NumberGame methodsFor: 'game' stamp: 'lg 10/1/2007 16:15'!
resetInputs
	self gameInputs do: [ :input | input setGameValue: minValue ].
! !

!NumberGame methodsFor: 'game' stamp: 'lg 10/2/2007 15:33'!
updateChoices
	| choices correct answers results stream |
	choices := self gameChoices.
	correct := self getGameValue.
	answers := (minValue to: maxSum) asArray shuffled reject: [ :x | x == correct]. 
	stream := answers readStream.
	results := OrderedCollection new.
	(choices size - 1) timesRepeat: [ results add: stream next ].
	results add: correct.
	results := results shuffled.
	stream := results readStream.
	choices do: [ :choice | choice setGameValue: stream next ].! !

!Morph methodsFor: '*ole-menus' stamp: 'lg 9/25/2007 11:31'!
addStandardHaloMenuItemsTo: aMenu hand: aHandMorph
	"Add standard halo items to the menu"

	| unlockables |

	self isWorldMorph ifTrue:
		[^ self addWorldHaloMenuItemsTo: aMenu hand: aHandMorph].

	self mustBeBackmost ifFalse:
		[aMenu add: 'send to back' translated action: #goBehind.
		aMenu add: 'bring to front' translated action: #comeToFront.
		self addEmbeddingMenuItemsTo: aMenu hand: aHandMorph.
		aMenu add: 'rip off' translated action: #ripoff.
		aMenu addLine].

	self addFillStyleMenuItems: aMenu hand: aHandMorph.
	self addBorderStyleMenuItems: aMenu hand: aHandMorph.
	self addDropShadowMenuItems: aMenu hand: aHandMorph.
	self addLayoutMenuItems: aMenu hand: aHandMorph.
	Preferences eToyFriendly ifFalse: [self addHaloActionsTo: aMenu].
	owner isTextMorph ifTrue:[self addTextAnchorMenuItems: aMenu hand: aHandMorph].
	aMenu addLine.
	self addToggleItemsToHaloMenu: aMenu.
	aMenu addLine.
	Preferences eToyFriendly ifFalse: [self addCopyItemsTo: aMenu].
	self addPlayerItemsTo: aMenu.
	Preferences eToyFriendly ifFalse: [self addExportMenuItems: aMenu hand: aHandMorph].
	Preferences eToyFriendly ifFalse: [self addStackItemsTo: aMenu].
	self addMiscExtrasTo: aMenu.
	Preferences eToyFriendly ifFalse: [Preferences noviceMode ifFalse:
		[self addDebuggingItemsTo: aMenu hand: aHandMorph]].

	aMenu addLine.
	aMenu defaultTarget: self.

	aMenu addLine.

	unlockables _ self submorphs select:
		[:m | m isLocked].
	unlockables size == 1 ifTrue:
		[aMenu
			add: ('unlock "{1}"' translated format: {unlockables first externalName})
			action: #unlockContents].
	unlockables size > 1 ifTrue:
		[aMenu add: 'unlock all contents' translated action: #unlockContents.
		aMenu add: 'unlock...' translated action: #unlockOneSubpart].

	aMenu defaultTarget: aHandMorph.
! !

!Morph methodsFor: '*ole' stamp: 'lg 9/25/2007 10:20'!
exchangeWith: morph 
	morph position: self position; extent: self extent.
	owner replaceSubmorph: self by: morph.! !

!Morph methodsFor: '*ole-bugfix' stamp: 'lg 10/2/2007 15:44'!
fixYourLayout
	| realExtent |
	realExtent := self extent.
	self extent: 10@10.
	self extent: realExtent.! !

!Morph methodsFor: '*ole-game' stamp: 'lg 10/2/2007 15:10'!
isGameChoice
	^false! !

!Morph methodsFor: '*ole' stamp: 'lg 10/1/2007 15:19'!
isGameInput
	^false! !

!Morph methodsFor: '*ole' stamp: 'lg 9/24/2007 17:00'!
ripOff
	| m |
	m := RipoffPatchMorph new initialize setTarget: self.
	owner addMorph: m after: self.
	owner removeMorph: self.
	self position: World activeHand position.
	World activeHand grabMorph: self.
! !

!Morph methodsFor: '*ole' stamp: 'lg 9/29/2007 13:03'!
ripoff
   | morph patch |
	morph := RippedOffMorph new setTarget: self.
	patch := RipoffPatchMorph new setTarget: morph.
	morph setPatch: patch.
	self exchangeWith: patch.
	morph center: World activeHand center.
	World activeHand grabMorph: morph.
! !

Morph subclass: #RipoffPatch
	instanceVariableNames: 'target'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!RipoffPatch methodsFor: '*ole' stamp: 'lg 9/24/2007 17:54'!
setTarget: morph
	target := morph.
	self position: morph position; extent: morph extent.! !

Morph subclass: #RipoffPatchMorph
	instanceVariableNames: 'target'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!RipoffPatchMorph methodsFor: 'initialization' stamp: 'lg 9/29/2007 13:03'!
initialize
	super initialize.
	self fillStyle: Color orange.
	self beSticky.
	self layoutPolicy: TableLayout new.
	self cellPositioning: #center; wrapCentering: #center; listCentering: #center.
	"XXX Add a text morph of a question mark"
	self cornerStyle: #rounded.
	! !

!RipoffPatchMorph methodsFor: 'initialization' stamp: 'lg 9/25/2007 10:19'!
setTarget: ripoffMorph 
	target := ripoffMorph.! !

!RipoffPatchMorph methodsFor: 'initialization' stamp: 'lg 9/25/2007 11:20'!
wantsDroppedMorph: morph event: evt
	^morph == target.

! !

ScriptableButton subclass: #GameButton
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!GameButton methodsFor: 'game' stamp: 'lg 10/2/2007 15:37'!
doButtonAction
	NumberGame answer: (self submorphs first contents asInteger)! !

!GameButton methodsFor: 'as yet unclassified' stamp: 'lg 10/2/2007 15:34'!
isGameChoice
	^true! !

!GameButton methodsFor: 'game' stamp: 'lg 10/2/2007 15:45'!
setGameValue: n 
	self submorphs first contents: n asString.
	self fixYourLayout.! !

AlignmentMorph subclass: #DigitChooserMorph
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OLE'!

!DigitChooserMorph class methodsFor: 'as yet unclassified' stamp: 'lg 9/21/2007 14:07'!
additionsToViewerCategories
	^ #( (basic ((slot numericValue 'The most recently pressed digit (or zero, initially).' Number readWrite Player getNumericValue Player setNumericValue:))))! !

!DigitChooserMorph methodsFor: '*ole' stamp: 'lg 9/21/2007 13:37'!
addButtonRows
	| row |
	#( (1 2 3) (4 5 6) (7 8 9) ) do:
		[ :digits |
			row := AlignmentMorph newRow vResizing: #spaceFill; cellInset: 3; yourself.
			digits do: [ :d | row addMorphBack: (self buttonFor: d)].
			self addMorph: row]! !

!DigitChooserMorph methodsFor: '*ole' stamp: 'lg 10/1/2007 16:45'!
buttonFor: digit 
	^ SimpleButtonMorph new target: NumberGame;
		label: digit asString font: Preferences standardEToysButtonFont;
		actionSelector: #answer:;
		arguments: { digit };
		hResizing: #spaceFill;
		vResizing: #spaceFill.! !

!DigitChooserMorph methodsFor: '*ole' stamp: 'lg 9/21/2007 13:46'!
initialize
	super initialize.
	self extent: 300@300.
	self layoutPolicy: TableLayout new.
	self listDirection: #bottomToTop.
	self vResizing: #spaceFill.
	self cellInset: 3.
	self cellPositioning: #center.
	self listCentering: #justified.
	self wrapCentering: #justified.
	borderWidth := 2.
	self addButtonRows.
! !
